
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/rtfm/autovnet/">
      
      
        <link rel="prev" href="../paradigm/">
      
      
        <link rel="next" href="../goals/">
      
      
      <link rel="icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>autovnet - autovnet</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#autovnet" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              autovnet
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../.." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="../" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../usage/" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../usage/help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_1" >
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_2" checked>
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#autovnet-basics" class="md-nav__link">
    autovnet Basics
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#under-the-hood" class="md-nav__link">
    Under the Hood
  </a>
  
    <nav class="md-nav" aria-label="Under the Hood">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#core-ip-simulation" class="md-nav__link">
    Core: IP Simulation
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#topology" class="md-nav__link">
    Topology
  </a>
  
    <nav class="md-nav" aria-label="Topology">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#to-nat-or-not-to-nat" class="md-nav__link">
    To NAT or not to NAT
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#example-route-configuration" class="md-nav__link">
    Example: Route Configuration
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#dns" class="md-nav__link">
    DNS
  </a>
  
    <nav class="md-nav" aria-label="DNS">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#example-domain-override" class="md-nav__link">
    Example: Domain Override
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#example-primary-dns" class="md-nav__link">
    Example: Primary DNS
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#listen-reverse-callback" class="md-nav__link">
    Listen: Reverse / Callback
  </a>
  
    <nav class="md-nav" aria-label="Listen: Reverse / Callback">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#diagram" class="md-nav__link">
    Diagram
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#proxy-forward-proxy" class="md-nav__link">
    Proxy: Forward / Proxy
  </a>
  
    <nav class="md-nav" aria-label="Proxy: Forward / Proxy">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#diagram_1" class="md-nav__link">
    Diagram
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#tun-11-ip-mapping" class="md-nav__link">
    Tun: 1:1 IP Mapping
  </a>
  
    <nav class="md-nav" aria-label="Tun: 1:1 IP Mapping">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#diagram_2" class="md-nav__link">
    Diagram
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5" >
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_2" >
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rdn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rdn/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rdn/listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rdn/tun/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rdn/dns/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_3" >
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rtfm/apt/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/rtfm/pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_4" >
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/metasploit/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/merlin/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/pwn/ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_5" >
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/hedgedoc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/collaboration/owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../usage/help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="autovnet">autovnet<a class="headerlink" href="#autovnet" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#autovnet">autovnet</a><ul>
<li><a href="#autovnet-basics">autovnet Basics</a></li>
<li><a href="#under-the-hood">Under the Hood</a><ul>
<li><a href="#core-ip-simulation">Core: IP Simulation</a></li>
<li><a href="#topology">Topology</a><ul>
<li><a href="#to-nat-or-not-to-nat">To NAT or not to NAT</a></li>
<li><a href="#example-route-configuration">Example: Route Configuration</a></li>
<li><a href="#dns">DNS</a><ul>
<li><a href="#example-domain-override">Example: Domain Override</a></li>
<li><a href="#example-primary-dns">Example: Primary DNS</a></li>
</ul>
</li>
</ul>
</li>
<li><a href="#listen-reverse-callback">Listen: Reverse / Callback</a><ul>
<li><a href="#diagram">Diagram</a></li>
</ul>
</li>
<li><a href="#proxy-forward-proxy">Proxy: Forward / Proxy</a><ul>
<li><a href="#diagram_1">Diagram</a></li>
</ul>
</li>
<li><a href="#tun-11-ip-mapping">Tun: 1:1 IP Mapping</a><ul>
<li><a href="#diagram_2">Diagram</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<h2 id="autovnet-basics"><code>autovnet</code> Basics<a class="headerlink" href="#autovnet-basics" title="Permanent link">&para;</a></h2>
<ol>
<li>
<p>Pick network block(s) that are not in use to simulate (e.g. <code>10.137.0.0/16</code>)</p>
<ul>
<li>Pretend this block belongs to a cloud provider. It's the wild west, so no traffic to or from these IPs are inherently good or bad </li>
</ul>
</li>
<li>
<p>Ask the Cyber Range network administrator very nicely to: </p>
<ul>
<li>Provision <em>1</em> central VM (the <code>autovnet server</code>) that <em>all</em> Blue Teams and <em>all</em> Red Teams can reach</li>
<li>Add <em>1</em> static firewall route at the competition firewall level that routes <em>all</em> traffic to simulated networks (e.g. <code>10.192.0.0/10</code>) to the <code>autovnet server</code></li>
<li><a href="#dns">Configure DNS</a> using one of the recommended strategies, so that <code>autovnet</code> can respond to special in-game DNS queries</li>
</ul>
</li>
<li>
<p>Configure and start the <code>autovnet server</code>.</p>
<ul>
<li>It will now respond to all IPs in the simulated network(s)</li>
</ul>
</li>
<li>
<p>Install <code>autovnet</code> (client) with the server's configuration / keys / etc. on all Red Team machines (super easy)</p>
</li>
<li>
<p>Red Teamers run <code>autovnet</code> commands and get instant (opt-in) access to randomized IP obfuscation / redirection that passes the acid tests with flying colors</p>
</li>
</ol>
<h2 id="under-the-hood">Under the Hood<a class="headerlink" href="#under-the-hood" title="Permanent link">&para;</a></h2>
<p><code>autovnet</code> uses quantum tunneling to achieve <em>Spooky Networking at a Distance</em> (<code>SNaaD</code>) ... or something.</p>
<p>But really, when you run an <code>autovnet</code> command, a lot of magic happens to achieve the end result.
While the source itself will always be the definitive source of truth for how things work, this should help demystify the moving pieces and the underlying techniques used.</p>
<h3 id="core-ip-simulation">Core: IP Simulation<a class="headerlink" href="#core-ip-simulation" title="Permanent link">&para;</a></h3>
<p>At its core, <code>autovnet</code> very efficiently "simluates" many, many devices controlled by <code>autovnet</code> players (Red Team).
In a standard deployment, a single <code>autovnet</code> server will receive and produce IP traffic from <em>millions</em> of unique IP addresses.</p>
<p>This is achieved by:</p>
<ol>
<li>
<p>Configuring a route on the exercise network to make sure all traffic to / from the "simluated" network is routed to the <code>autovnet server</code></p>
</li>
<li>
<p>Using the <a href="https://blog.cloudflare.com/how-we-built-spectrum/">Linux AnyIP</a> trick to cause the <code>autovnet server</code> to adopt / respond to all traffic in the simluated network.</p>
</li>
</ol>
<p>The <code>AnyIP</code> trick does the heavy lifting here.
It's built in to a vanilla Linux Kernel, and is the underlying technology for why all of <code>127.0.0.0/8</code> works like <code>127.0.0.1</code> (<code>localhost</code>).</p>
<h3 id="topology">Topology<a class="headerlink" href="#topology" title="Permanent link">&para;</a></h3>
<p>Here is an example network topology incorporating <code>autovnet</code>:</p>
<p><img alt="deployment.svg" src="../../img/deployment.svg" /></p>
<h4 id="to-nat-or-not-to-nat">To <code>NAT</code> or not to <code>NAT</code><a class="headerlink" href="#to-nat-or-not-to-nat" title="Permanent link">&para;</a></h4>
<p>Some networks choose to <a href="../paradigm/#n-1-red-teaming-nat">NAT all outbound traffic from Red Team</a>.
<code>autovnet</code> should still work as expected, as long as the <code>autovnet</code> server's outbound connections are <em>not</em> subject to the <code>NAT</code>.
So you can <code>NAT</code> if you really want to, but <code>autovnet</code> supercedes any advatange you'd get from <code>NAT</code>.</p>
<h4 id="example-route-configuration">Example: Route Configuration<a class="headerlink" href="#example-route-configuration" title="Permanent link">&para;</a></h4>
<p>The most important part of your network configuration is the static route that bends traffic destined for the <code>autovnet</code> simluation block to the <code>autovnet</code> server, where it can be processed.</p>
<p>https://docs.netgate.com/pfsense/en/latest/routing/static.html</p>
<h4 id="dns">DNS<a class="headerlink" href="#dns" title="Permanent link">&para;</a></h4>
<p>To use <code>autovnet</code>'s awesome <code>dns</code> features, you need to incorporate <code>autovnet</code> into your <code>dns</code> setup.</p>
<p>There are mutliple ways to do this in a functional way.
This guide includes example configurations.</p>
<h5 id="example-domain-override">Example: Domain Override<a class="headerlink" href="#example-domain-override" title="Permanent link">&para;</a></h5>
<p>Part of your <code>autovnet</code> game config is a made-up <a href="https://en.wikipedia.org/wiki/List_of_Internet_top-level_domains">TLD</a> that in-game <code>dns</code> registrations will use.
(This approach allows you to allow Red Team to freely register domains without accidentally or intentionally <em>breaking the internet</em> for themselves and Blue Team.)</p>
<ul>
<li>For example, if <code>.avn</code> is your <code>tld</code>, then Red Team can register domains like <code>foo.avn</code>, <code>foo.bar.avn</code>, etc.</li>
</ul>
<p>The <code>autovnet</code> server is the authority for the <code>.avn</code> domain, so we need to configure <code>dns</code> so that queries for <code>*.avn</code> domains are sent to the <code>autovnet</code> server.</p>
<p>The recommended topolgy is shown below.</p>
<p>Here, there is an existing <code>dns</code> server (the game firewall) that is set as the primary <code>dns</code> server for all <code>blue</code> and <code>red</code> systems.</p>
<ul>
<li>Configure the existing <code>dns</code> server to route <em>only</em> queries for the game TLD (e.g. <code>*.avn</code>) to the <code>autovnet</code> server</li>
<li>This reduces server load and prevents internet distruption if the <code>autovnet</code> server is ever unavailable, since only <code>*.avn</code> queries are handled</li>
</ul>
<p><img alt="dns_override.svg" src="../../img/dns_override.svg" /></p>
<p>You (the network admin) need to figure out how to set this up in your network. These examples may help:</p>
<ul>
<li><a href="https://docs.netgate.com/pfsense/en/latest/services/dns/forwarder-overrides.html#domain-overrides">Example: <code>pfSense</code> Domain Override</a></li>
<li><a href="https://stackoverflow.com/questions/22313142/wildcard-subdomains-with-dnsmasq">Example: <code>dnsmasq</code></a></li>
</ul>
<h5 id="example-primary-dns">Example: Primary DNS<a class="headerlink" href="#example-primary-dns" title="Permanent link">&para;</a></h5>
<p>If you are unable to configure the existing <code>dns</code> server, or the recommended topology above does not work for you, <code>autovnet</code> will function as a primary <code>dns</code> server, if needed.</p>
<ul>
<li>Set the <code>autovnet</code> server as the primary <code>dns</code> server for all Blue and Red systems<ul>
<li>If using <code>DHCP</code> or a <code>VPN</code> for Blue / Red networks, update the configuration to use <code>autovnet</code> as the <code>dns</code> server</li>
</ul>
</li>
<li>Set the existing <code>dns</code> server as the secondary <code>dns</code> server for all Blue and Red systems (in case the <code>autovnet</code> server is ever unavailable)</li>
<li>Caution: the <code>autovnet</code> server should use the <code>existing</code> dns server (or a public <code>dns</code> server like <code>1.1.1.1</code>, <code>8.8.8.8</code>, <code>9.9.9.9</code>, etc.) as its primary <code>dns</code>.<ul>
<li>avoid a <code>dns</code> loop - the <code>autovnet</code> server needs a valid "upstream" <code>dns</code> server it can forward non-game queries to</li>
</ul>
</li>
</ul>
<p><img alt="dns_primary.svg" src="../../img/dns_primary.svg" /></p>
<h3 id="listen-reverse-callback">Listen: Reverse / Callback<a class="headerlink" href="#listen-reverse-callback" title="Permanent link">&para;</a></h3>
<p>The <code>listen</code> primitive is based on <a href="https://www.ssh.com/academy/ssh/tunneling/example"><code>SSH</code> Remote Port Forwarding</a>.
The <code>autovnet server</code> runs an <code>SSH</code> server configured with <code>GatewayPorts clientspecified</code>, which lets the <code>SSH</code> client (<code>autovnet</code> player) bind to any <code>IP</code> address assigned to the <code>autovnet server</code>.</p>
<p>Because of the <code>AnyIP</code> trick at the core of <code>autovnet</code>, players can bind to any of the <code>IP</code>s simulated by <code>autovnet</code>, because <code>SSH</code> considers them all valid addresses.</p>
<p>When you (the player) create a new <code>listen</code>er, the <code>autovnet client</code> (your machine) randomly chooses an <code>IP</code> address, and creates a <code>ssh -R RANDOM_IP:REMOTE_PORT:LOCAL_IP:LOCAL_PORT ...</code> tunnel.</p>
<p>When targets connect to <code>RANDOM_IP:REMOTE_PORT</code>, the connection is proxied locally to your machine at <code>LOCAL_IP:LOCAL_PORT</code>.</p>
<p>This feature is secured by the <code>SSH</code> protocol: to create a <code>listen</code>er, you must have the <code>autovnet</code> player <code>SSH</code> key, which is securely distributed to players only as part of the <code>autovnet</code> game configuration.</p>
<h4 id="diagram">Diagram<a class="headerlink" href="#diagram" title="Permanent link">&para;</a></h4>
<p>Here is an example of an obfuscated Blue -&gt; Red callback, using the <code>listen</code> primitive</p>
<p><img alt="listen.svg" src="../../img/listen.svg" /></p>
<h3 id="proxy-forward-proxy">Proxy: Forward / Proxy<a class="headerlink" href="#proxy-forward-proxy" title="Permanent link">&para;</a></h3>
<h4 id="diagram_1">Diagram<a class="headerlink" href="#diagram_1" title="Permanent link">&para;</a></h4>
<p>Here is an example of an obfuscated Red -&gt; Blue connection</p>
<p><img alt="proxy.svg" src="../../img/proxy.svg" /></p>
<h3 id="tun-11-ip-mapping">Tun: <code>1:1</code> IP Mapping<a class="headerlink" href="#tun-11-ip-mapping" title="Permanent link">&para;</a></h3>
<p>The <code>tun</code> feature of <code>autovnet</code> is one of its most complex.</p>
<p>It allows:</p>
<ul>
<li>Delivery of arbitrary <code>IP</code> packets, through the use of a local <a href="https://en.wikipedia.org/wiki/TUN/TAP">TUN interface</a> (like a <a href="https://en.wikipedia.org/wiki/Virtual_private_network">VPN</a> provides.)</li>
<li>Remapping the remote end of the <code>tun</code> to an abitrary <code>IP</code> in the <code>autovnet</code> <code>IP</code> pool<ul>
<li>This means that the <code>IP</code>s given by <code>tun</code> span the entire <code>autovnet</code> pool, and therefore also scale up to the entire <code>IP</code> space</li>
</ul>
</li>
</ul>
<p>The <code>tun</code> feature is powered by:</p>
<ul>
<li><a href="https://en.wikipedia.org/wiki/Virtual_private_network"><code>nebula</code></a>, which we use to create an <a href="https://en.wikipedia.org/wiki/Overlay_network">overlay network</a></li>
<li>A custom <a href="https://en.wikipedia.org/wiki/IP_address_management">IPAM</a> API, used to securely issue <code>nebula</code> client configurations to players, so they can join the overlay network</li>
<li><a href="https://linux.die.net/man/8/iptables"><code>iptables</code></a> on the <code>autovnet</code> server, and a custom API that manages <code>IP</code> mappings by creating <a href="https://www.linuxtopia.org/Linux_Firewall_iptables/x4658.html">SNAT</a> and <a href="https://www.linuxtopia.org/Linux_Firewall_iptables/x4013.html">DNAT</a> rules</li>
<li>Some <code>ip route</code>s and <code>ip rule</code>s on the client / <code>autovnet</code> player system to ensure traffic that should be routed through the <code>tun</code> are actually routed through the <code>tun</code></li>
</ul>
<p>The <code>tun</code> commands provided by <code>autovnet</code> do everything for you, so everything <a href="../../usage/rdn/tun/">just works</a>.</p>
<p>You might be thinking:</p>
<blockquote>
<p><code>iptables</code>? <a href="../">You said that was bad!</a></p>
</blockquote>
<p><code>iptables</code> is a bad solution for <code>IP</code> simulation itself (e.g. creating billions of <code>iptables</code> rules, 1 for each <code>IP</code> to simluate) - that is an <code>O(simulation_size)</code> solution (very big number).
But it is a great solution in the context of <code>tun</code>.</p>
<p><code>tun</code> requires <code>O(num_active_tuns)</code>-many <code>iptables</code> rules, and <code>O(num_active_tuns) ~= O(num_players)</code> (managable number).
But the <code>IP</code> that it gives out are from the full, <code>O(simlutation_size)</code> <code>IP</code> pool!</p>
<p>Additionally, other <em>bad</em> uses of <code>iptables</code> fail when players are behind a <code>NAT</code>, or using a VM that is on a <code>NAT</code> network will fail (e.g. redirecting packets from a pivot box outside of the <code>NAT</code> will fail).
The use of the overlay network solves this - all players (which already can connect to the <code>autovnet</code> server) become directly reachable (1 logical hop, same subnet) when they join the <code>tun</code> network.
So even if the player system is behind multiple <code>NAT</code>s, the <code>iptables</code> rules that are created will work as expected.</p>
<p>Other bad ideas include custom web GUIs for creating <code>iptables</code> rules - it's error prone and tedious.
<code>autovnet</code> intentionally does not expose full <code>iptables</code> functionality to players - it safely creates exactly the <code>iptables</code> rules you need, exactly when you need them.</p>
<p>So <code>autovnet</code>'s <code>tun</code> feature the best of all the worlds worlds; billions of <code>IP</code>s, at the cost of a very small number of simple <code>iptables</code> rules,
that are programatically created and deleted for you under the hood.</p>
<h4 id="diagram_2">Diagram<a class="headerlink" href="#diagram_2" title="Permanent link">&para;</a></h4>
<p>Here is a quick diagram showing <code>tun</code> in action.</p>
<p><img alt="tun.svg" src="../../img/tun.svg" /></p>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": "../..", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "../../assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>